/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

package rpcs.system;

import com.sun.java.swing.JDialog;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

import rpcs.system.*;

// public class RPCSCopyright extends JDialog {
public class RPCSCopyright extends Dialog {
	JPanel Panel;
	JPanel SPanel;
	URL RPCSCodeBase;
	JButton B1, B2, B3;
	WindowListener tWL;

	public RPCSCopyright(Frame frame) {
		super(frame);
	}

	public RPCSCopyright(Frame frame, String title) {
		super(frame, title);
	}

	public RPCSCopyright(Frame frame, String title, boolean modal) {
		super(frame, title, modal);
	}

	public void Init(URL CB, String image, String msg) {
		tWL = new WindowAdapter() {
		   public void windowClosing(WindowEvent e) {System.exit(0); }
		};
		addWindowListener(tWL);

		RPCSCodeBase = CB;
		Panel = new JPanel(new BorderLayout());
		setLayout(new BorderLayout());
		ImageIcon iCopyright = loadImageIcon(image, msg);
		setSize(iCopyright.getIconWidth() + 20, iCopyright.getIconHeight() + 50);
//		getContentPane().add(Panel, "Center");
		add(Panel, "Center");
		Panel.add(new JLabel(iCopyright), "Center");
		SPanel = new JPanel(new BorderLayout());
		B1 = new JButton("I Accept");
		B1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
			}
		});
		SPanel.add(B1, "West");
		B2 = new JButton("I Reject");
		B2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		SPanel.add(B2, "East");
		B3 = new JButton("Version v0.1");
		B3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
			}
		});
		SPanel.add(B3, "Center");

		Panel.add(SPanel, "South");
	}

	public ImageIcon loadImageIcon(String filename, String description) {
	   URL url;

		if (RPCSCodeBase.getHost() == null)
		   return new ImageIcon(filename, description);
		try {
		   url = new URL(RPCSCodeBase, filename);
		} catch(MalformedURLException e) {
			System.out.println("Error in : loadImageIcon");
			return null;
		}
		return new ImageIcon(url, description);
	}

	public void setAbout() {
		SPanel.remove(B1);
		SPanel.remove(B2);
		removeWindowListener(tWL);
		tWL = new WindowAdapter() {
		   public void windowClosing(WindowEvent e) {
			setVisible(false);
		   }
		};
		addWindowListener(tWL);
		setVisible(false);
	}

	public void setVisible(boolean b) {
		Dimension pdim = getParent().getSize();
		Point ppt = getParent().getLocationOnScreen();
		Dimension cdim = getSize();
		setLocation(ppt.x + (pdim.width - cdim.width)/2,
			ppt.y + (pdim.height - cdim.height)/2);
		super.setVisible(b);
	}
}
