
/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

package rpcs.system;

import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import rpcs.system.*;

public class RPCSToolBar extends JToolBar {
	URL RPCSCodeBase;
	RPCSToolBar tTB;
	JButton tB;
	RPCSParam Params;

	public RPCSToolBar(URL CB) {
		super();
		RPCSCodeBase = CB;
	   	tTB = this;

		addToToolBar(this, "RPCSopen", "Open file");
		addToToolBar(this, "RPCSsave", "Save file");
		addSeparator();
		addToToolBar(this, "RPCSQksave", "Quick Save");
		addSeparator();
		addToToolBar(this, "RPCSBlank", "Initiate Round");
		addToToolBar(this, "RPCSBlank", "Edit Action Sequence");
		addSeparator(); 
		addToToolBar(this, "RPCSzoomin", "Zoom In");
		addToToolBar(this, "RPCSzoomout", "Zoom Out");
		addSeparator(); 
		addToToolBar(this, "RPCSGroup", "Group Setup");
		addToToolBar(this, "RPCSGroupAction", "Group Actions");
		addSeparator(); 
	}

	public void addToToolBar(JToolBar toolBar, String name, String tip) {
	   	tB = new JButton(loadImageIcon("rpcs/images/" + name + ".gif", name));
	   	toolBar.add(tB);

		tB.setToolTipText(tip);
		tB.setMargin(new Insets(0,0,0,0));
		tB.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
// System.out.println("TB In Click: " + e.paramString());
				if (e.getClickCount() == 2) {
// System.out.println("TB Dbl Click on: ");
				}
				else {
					tTB.processTBClick(e);
				}
			}
		});
	}

	public void processTBClick(MouseEvent e) {
	   String tTTT = ((JComponent )e.getComponent()).getToolTipText();
System.out.println("Processing TB Click: " + e.paramString() + " " + tTTT);
		if (tTTT.equals("Group Setup")) {
		   Params.aRPCSMain.RPCSGrp.setVisible(true);
		}
		else if (tTTT.equals("Group Actions")) {
		   Params.aRPCSMain.RPCSGrpAction.setVisible(true);
		}
		else if (tTTT.equals("Open file")) {
		   RPCSOpen FOpen = new RPCSOpen(Params);
		}
		else if (tTTT.equals("Save file")) {
		   RPCSSave FSave = new RPCSSave(Params);
		}
		else if (tTTT.equals("Zoom In")) {
		   Params.aRPCSMain.pRPCSMap.ZoomIn();
		}
		else if (tTTT.equals("Zoom Out")) {
		   Params.aRPCSMain.pRPCSMap.ZoomOut();
		}
		else if (tTTT.equals("Initiate Round")) {
		   Params.aRPCSMain.RPCSActionScrn.setVisible(true);
		}
		else if (tTTT.equals("Edit Action Sequence")) {
		   Params.aRPCSMain.RPCSInitiativeScrn.setVisible(true);
		}
	}

	public ImageIcon loadImageIcon(String filename, String description) {
	   URL url;

		if (RPCSCodeBase.getHost() == null)
		   return new ImageIcon(filename, description);
		try {
		   url = new URL(RPCSCodeBase, filename);
		} catch(MalformedURLException e) {
			System.out.println("Error in : loadImageIcon");
			return null;
		}
		return new ImageIcon(url, description);
	}

	public void setParam(RPCSParam param) {
		Params = param;
	}
}
